<br>

<p align="center">
<img src="logo.png"  width="55%" />
</p>

<p align="center">
vue2-text-annotation
</p>

# Introduction
vue2-text-annotation is an easy-to-use component for text annotation. It achieves the features of locating, extracting and tagging entities in text. The operation be like:

<img src="./images/operation.gif"   />

[Online preview](https://rfc8kw.csb.app/)

[![Edit on CodeSandbox](https://codesandbox.io/static/img/play-codesandbox.svg)](https://codesandbox.io/s/buttons-pagination-rfc8kw?file=/src/App.vue:125-150)

```js
// data set:
[
  {
    content:"Vue.js",
    category:"framework",
    start:0,
    end:6,
  },
  {
    content:"Evan You",
    category:"name",
    start:521,
    end:529,
  },
  {
    content:"JavaScript",
    category:"language",
    start:24,
    end:34,
  }
]
```
The data set generated by `vue2-text-annotation` can be used for Natural Language Processing (NLP) model training.



# Getting started
### Installation
```bash
npm install --save vue-manual-data-masking
```
### Usage
```js
<template>
  <TextAnnotation
    v-model="textAnnotations"
    :text="text"
  />
</template>

<script>
import TextAnnotation from "vue2-text-annotation";

export default {
  components: {
    TextAnnotation,
  },
  data() {
    return {
      text: "Vue.js is a progressive JavaScript framework, which is used to build UIs (User Interfaces) and SPAs (Single-page Applications). This framework is famous for its fast-paced learning curve. It is such an easy to learn and approachable library that with the knowledge of HTML, CSS, and JavaScript, we can start building web applications in Vue.js. The fast learning curve is kind of a signature of this framework. It is a versatile framework for our need as a library or a full-fledged framework for building huge web apps.\nEvan You have created this framework. The idea of Evan You behind this framework is to build the best framework by combining the best features from already existing Angular and react Frameworks. Before building Vue.js, Evan You was working at Google. Inc and worked on Angular based projects. So, he came up with the idea of building his own framework. He picked the best parts of Angular, like template syntax, easy to use, and picked the best parts of React as well, like two-way data binding, the concept of props, component-based approach, and combined them to make a new framework Vue.js better than both of them.",
      textAnnotations: [{
        content: "Vue.js",
        category: "framework",
        start:0,
        end:6,
      }]
    }
  }
};
```

### Demo


# Data masking mode



## Demo
Before data masking: <br/>
<img src="./images/before-masking.png"  wight="150" /> <br/> <br/>
When data masking: <br/>
<img src="demo.gif"  wight="150" /> <br/><br/>
After data masking: <br/>
<img src="./images/after-masking.png"  wight="150" />

[![Edit on CodeSandbox](https://codesandbox.io/static/img/play-codesandbox.svg)](https://codesandbox.io/s/vue-manual-data-masking-yt6cc?file=/src/App.vue)


## Options

| Property | Description | Type | Required | Default |
| -------- | ----------- | ---- | -------- | ------- |
| v-model | Data been masked<br>e.g. <br>[{ content: "080080080", category: "phone number", start: 0, end: 5 }] | Array<Masked> | true | [] |
| text | text | String | true | |
| maskingTextColor | color of masking text | String | false |"#35495e" |
| maskingBgColor | color of masking background | String | false | "#41b883"|
| maxHeight | max height of data masking container | Number or Null | false | null | |

## Events
`afterMasking` event will be emitted when new sensitive data been masked. textAfterMasking can be used inside of the callback function registered in advance. 

## Build Setup

```bash
# install dependencies
npm install
# serve with hot reload at localhost:8888
npm run serve
# build for production with minification
npm run build
```
